
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Survey_response_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const survey_response_items = await db.survey_response_items.create(
            {
                id: data.id || undefined,
        
        answer_value: data.answer_value
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await survey_response_items.setSurvey_response( data.survey_response || null, {
            transaction,
        });
        
        await survey_response_items.setSurvey_question( data.survey_question || null, {
            transaction,
        });
        
        await survey_response_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return survey_response_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const survey_response_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                answer_value: item.answer_value
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const survey_response_items = await db.survey_response_items.bulkCreate(survey_response_itemsData, { transaction });

        // For each item created, replace relation files
        

        return survey_response_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const survey_response_items = await db.survey_response_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.answer_value !== undefined) updatePayload.answer_value = data.answer_value;
        
        
        updatePayload.updatedById = currentUser.id;

        await survey_response_items.update(updatePayload, {transaction});

        
        
        if (data.survey_response !== undefined) {
            await survey_response_items.setSurvey_response(
              
              data.survey_response,
              
              { transaction }
            );
        }
        
        if (data.survey_question !== undefined) {
            await survey_response_items.setSurvey_question(
              
              data.survey_question,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await survey_response_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return survey_response_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const survey_response_items = await db.survey_response_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of survey_response_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of survey_response_items) {
                await record.destroy({transaction});
            }
        });


        return survey_response_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const survey_response_items = await db.survey_response_items.findByPk(id, options);

        await survey_response_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await survey_response_items.destroy({
            transaction
        });

        return survey_response_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const survey_response_items = await db.survey_response_items.findOne(
            { where },
            { transaction },
        );

        if (!survey_response_items) {
            return survey_response_items;
        }

        const output = survey_response_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.survey_response = await survey_response_items.getSurvey_response({
            transaction
        });
        
        
        output.survey_question = await survey_response_items.getSurvey_question({
            transaction
        });
        
        
        output.organizations = await survey_response_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.survey_responses,
        as: 'survey_response',
        
        where: filter.survey_response ? {
          [Op.or]: [
            { id: { [Op.in]: filter.survey_response.split('|').map(term => Utils.uuid(term)) } },
            {
              overall_comment: {
                [Op.or]: filter.survey_response.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.survey_questions,
        as: 'survey_question',
        
        where: filter.survey_question ? {
          [Op.or]: [
            { id: { [Op.in]: filter.survey_question.split('|').map(term => Utils.uuid(term)) } },
            {
              prompt: {
                [Op.or]: filter.survey_question.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.answer_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'survey_response_items',
                        'answer_value',
                        filter.answer_value,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.survey_response_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'survey_response_items',
                        'answer_value',
                        query,
                    ),
                ],
            };
        }

        const records = await db.survey_response_items.findAll({
            attributes: [ 'id', 'answer_value' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['answer_value', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.answer_value,
        }));
    }

    
};

